import abc

class Interface0(object):
    __metaclass__ = abc.ABCMeta

    """Pure virtural class for the Bioinformatics Data Interface.
    Every BDI implementation should be a subclass (possibly indirect) of this class.
    """

    @abc.abstractmethod
    def interface_version(self):
        pass

    @abc.abstractmethod
    def data_version(self):
        pass


    @abc.abstractmethod
    def get_Gene(self,ac):
        pass

    @abc.abstractmethod
    def get_Transcript(self,ac):
        pass

    @abc.abstractmethod
    def get_TranscriptAlignment(self,ac,ref):
        pass


    @abc.abstractmethod
    def get_gene_transcripts(self,ac,ref):
        pass

    @abc.abstractmethod
    def get_protein_acs_for_sequence(self,pseq):
        pass

    @abc.abstractmethod
    def get_chromosome_slice(self,chr,gs_i,ge_i):
        pass

## <LICENSE>
## Copyright 2014 BDI Contributors (https://bitbucket.org/invitae/bdi)
## 
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
## 
##     http://www.apache.org/licenses/LICENSE-2.0
## 
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
## </LICENSE>
